<?php

# check if session is valid
$newTarget = '/app/berogui/index.php?m=RebootReset';
include('/usr/local/www/berogui/includes/session.php');
unset($newTarget);

/**
 * @file
 * Factory Reset, Datenbank löschen und neu erzeugen
 */
chdir('../..');

include('./includes/variables.php');
include('./misc/database.php');
include('/usr/fallback/beroConf.php');

require_once('./modules/PstnHardware/PstnHardware.php');

/* ######## Functions ####### */

function load_wizard_config($filename = '/tmp/wizard-voip.conf')
{
	return parse_ini_file($filename, true);
}

function set_sip_profile($ba, $scenario, $sip_cfg)
{
	$name 	  = sqlite_escape_string($sip_cfg['name'])	;
	$server   = sqlite_escape_string($sip_cfg['server'])	;
	$user     = sqlite_escape_string($sip_cfg['user'])	;
	$secret   = sqlite_escape_string($sip_cfg['secret'])	;
	$register = sqlite_escape_string($sip_cfg['register'])	;	

	if (strcmp($scenario, 'Gateway') == 0)
	{
		$ba -> insert_("INSTERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register) VALUES ('$name', '$server', '$server', '$server', '$user', '$secret', '$register')");	
	}
	else
	{
		$trunk_config = sqlite_escape_string($sip_cfg['trunk_config']);
		$ba -> insert_("INSTERT INTO sip (name, sip_registrar, sip_domain, sip_proxy, user, secret, register, config) VALUES ('$name', '$server', '$server', '$server', '$user', '$secret', '$register', '$trunk_config')");	
	}
}

function set_pstn_hardware_as_gateway_scenario($ba, $port_type, $pstn_cfg)
{
	$group = $pstn_cfg['group'];

	$type = 'analog';
	if (strcmp($port_type, 'GSM') == 0)
	{
		$type = 'gsm';
	}
	else if (strcmp($port_type, 'PRI') == 0 || strcmp($port_type, 'BRI') == 0)
	{
		$type = 'isdn';
		$ptp_or_ntte = (isset($pstn_cfg['ptp']) ? "ptp='".sqlite_escape_string($pstn_cfg['ptp'])."'" : "ntteSW='".sqlite_escape_string($pstn_cfg['ntte'])."', ntteHW='".sqlite_escape_string($pstn_cfg['ntte'])."'");
		$ba -> update("UPDATE $type SET $ptp_or_ntte WHERE port_type='$port_type'");
	
		if (isset($pstn_cfg['t1e1']))
		{
			$ba -> update("UPDATE cas SET protocol='".sqlite_escape_string($pstn_cfg['t1e1'])."', termination='".sqlite_escape_string($pstn_cfg['ntte'])."' WHERE port_type='$port_type'");
		}
	}	

	foreach (explode('-', $pstn_cfg['ports']) as $port)
	{
		$ba -> update("UPDATE $type SET gr='". sqlite_escape_string($group) ."' WHERE port='". sqlite_escape_string($port) ."'");
	}
}

function set_pstn_hardware($ba, $scenario, $port_type, $pstn_cfg)
{
	if (strcmp($scenario, 'Pbx') == 0)
	{
		set_pstn_hardware_as_pbx_scenario($ba, $port_type, $pstn_cfg);
		return 1;
	}

	set_pstn_hardware_as_gateway_scenario($ba, $port_type, $pstn_cfg);
	return 1;
}

function set_dialplan_rules($ba, $dialplan_rules)
{
	// init input variable
	$fromDirection  = sqlite_escape_string($dialplan_rules['fromDirection']);
	$toDirection	= sqlite_escape_string($dialplan_rules['toDirection'])	;
	$dest		= sqlite_escape_string($dialplan_rules['dest'])		;
	$newDest	= sqlite_escape_string("\\".$dialplan_rules['newDest'])	;
	$src		= sqlite_escape_string($dialplan_rules['src'])		;
	$newSrc		= sqlite_escape_string("\\".$dialplan_rules['newSrc'])	;

	// SIP => PSTN
	$fromId  = "a:". $dialplan_rules['fromId'];
	$toId	 = "g:". $dialplan_rules['toId']  ;
	$ba -> insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc) VALUES ('$fromDirection', '$toDirection', '$fromId', '$toId', '$dest', '$newDest', '$src', '$newSrc')");

	// PSTN => SIP
	$fromId  = "g:". $dialplan_rules['toId']  ;
	$toId	 = "p:". $dialplan_rules['fromId'];
	$ba -> insert_("INSERT INTO dialplan (fromDirection, toDirection, fromId, toId, dest, newDest, src, newSrc) VALUES ('$toDirection', '$fromDirection', '$fromId', '$toId', '$dest', '$newDest', '$src', '$newSrc')");
}

###############################

// init factory reset mode
$wizard_factory_reset = false;
$normal_factory_reset = true ;

// init wizard factory reset
if (false && isset($_GET['wizard']) && $_GET['wizard'])
{
	$normal_factory_reset = false;
	$wizard_factory_reset = true ; 
}

// init normal factory reset
if ($normal_factory_reset)
{
	$inserts=array();
	// keep sip-settings
	if (isset($_POST['keep_sip_set'])){
		$ba = new beroAri();
		$q = $ba->select('SELECT * FROM sip;');

		while ($entry=sqlite_fetch_array($q, SQLITE_ASSOC)){
			unset($fields);
			unset($values);
			foreach ($entry as $key => $val){
				$fields .= ((strlen($fields) == 0) ? '' : ',') . $key;
				$values .= ((strlen($values) == 0) ? '' : ',') . '\'' . sqlite_escape_string($val) . '\'';
			}
			$inserts[] = 'INSERT INTO sip (' . $fields . ') VALUES (' . $values . ');';
		}
	}

	// keep cloud-settings
	if (isset($_POST['keep_cloud_set'])){
		$ba = new beroAri();
		$nameArray = array('proxyEnabled', 'proxyAddress', 'proxyPort', 'proxyType', 'proxyUser', 'proxySecret', 'cloudAddress');
		foreach ($nameArray as $name) {
			$cloudSettings[$name]=$ba->get($name);
		}
	}

	// keep prefix-settings
	if (isset($_POST['keep_prefix_set'])){
		$ba = new beroAri();
		$nameArray = array('national_code', 'international_code');
		foreach ($nameArray as $name) {
			$prefixSettings[$name]=$ba->get($name);
		}

	}

	//keep ACL Settings 
	if (isset($_POST['keep_set'])) {
		$ba = new beroAri();
		$q = $ba->select('SELECT * FROM acl;');

		while ($entry=sqlite_fetch_array($q, SQLITE_ASSOC)){
			unset($fields);
			unset($values);
			foreach ($entry as $key => $val){
				$fields .= ((strlen($fields) == 0) ? '' : ',') . $key;
				$values .= ((strlen($values) == 0) ? '' : ',') . '\'' . sqlite_escape_string($val) . '\'';
			}
			$inserts[] = 'INSERT INTO acl (' . $fields . ') VALUES (' . $values . ');';
		}
	}
}

// delete database ari.db
exec('/bin/rm /usr/conf/ari.db');

//Create new db
$ba = new beroAri();

if ($ba->is_error()){
	echo '<script>alert("' . $ba->error() .'");</script>';
}

// reset rootdb
$bc = new beroConf('root');
$bc->exec_sql("DELETE FROM root WHERE key NOT IN ('root-version', 'lan-mtu', 'lan-iface', 'lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-dhcp', 'lan-mode', "
	. "'lan-ports', 'msp-iface', 'msp-ipaddr', 'app-image', 'app-status', 'ntphost', 'cloud_enable', 'cloud_key', 'lan-nameserver', 'vlan-enable', 'vlan-id', "
	. "'vlan-prio', 'wan-dhcp', 'wan-ipaddr', 'wan-netmask', 'wan-gateway', 'bonding-mode', 'bonding-miimon', 'bonding-updelay', 'bonding-downdelay');");


// wizard factory reset
if ($wizard_factory_reset)
{
	// read config file
	$wizard_cfg = load_wizard_config();

	// create and set SIP profile
	set_sip_profile($ba, $wizard_cfg['Scenario'], $wizard_cfg['Sip']);

	// create and set PSTN hardware configuration
	$type = $wizard_cfg['Pstn']['type'];
	unset($wizard_cfg['Pstn']['type']) ;
	set_pstn_hardware($ba, $wizard_cfg['Scenario'], $type, $wizard_cfg['Pstn']);

	// create and set Dialplan rules
	set_dialplan_rules($ba, $wizard_cfg['Dialplan']);

	// activate
	// TODO
/*
	// update network settings
	if (isset($wizard_cfg['Network']['update']) && $wizard_cfg['Network']['update'])
	{
		unset($wizard_cfg['Network']['update']);
		update_network_configuration($wizard_cfg['Network']);
	}
*/
}

// normal factroy reset
if ($normal_factory_reset)
{
	//keep network settings
	if (!isset($_POST['keep_set'])) {

		$delArray = array('lan-ipaddr', 'lan-netmask', 'lan-gateway', 'lan-nameserver', 'ntphost', 'vlan-enable', 'vlan-id', 
			'vlan-prio', 'lan-mode', 'wan-dhcp', 'wan-ipaddr', 'wan-netmask', 'wan-gateway', 'bonding-mode', 'bonding-miimon', 
			'bonding-updelay', 'bonding-downdelay');
		foreach ($delArray as $delItem) {
			$bc->delete('root', $delItem);
		}
		unset($delArray);

		$bc->set('root', 'lan-iface', 'eth0');
		$bc->set('root', 'lan-dhcp', 'yes');
		$bc->set('root', 'lan-mtu', '1500');
		$bc->set('root', 'beroAvahi-enabled', '1');
	}

	// set a default ntphost (if none is set, but configuration is static)
	if ($bc->get('root', 'lan-dhcp') != 'yes') {
		if (strlen($bc->get('root', 'ntphost')) == 0) {
			$bc->set('root', 'ntphost', 'ntp0.fau.de');
		}
	}
	if (!isset($_POST['keep_cloud_set'])){
		$bc->exec_sql("DELETE FROM root WHERE key IN ('cloud_enable', 'cloud_key');");
	}
	//restore apps
	if (!isset($_POST['keep_app_set'])){
	
		exec('/bin/mount -o remount,rw /home/admin/');

		if ($handle = opendir('/home/admin/apps/')) {
			while (false !== ($file = readdir($handle))) {
				if (($file == '.') || ($file == '..')) {
					continue;
				}
				exec('/bin/rm -rf /home/admin/apps/' . $file);
				exec('/bin/rm -rf /home/admin/www/' . $file);
			}
			closedir($handle);
		}

		exec('/bin/rm -rf /usr/conf/userapp');
		exec('sync');
		exec('/bin/mount -o remount,ro /home/admin/');
	}

	$bc->set('root', 'msp-iface', 'eth1');
	$bc->set('root', 'msp-ipaddr', 'auto');
	$bc->set('root', 'app-status', 'running');
	$bc->set('root', 'userapp-enabled', '1');

	// restore settings
	foreach ($inserts as $sql) {
		$ba->insert_($sql);
	}

	// restore cloud-settings
	if (isset($_POST['keep_cloud_set'])) {
		foreach ($cloudSettings as $key => $value) {
			$ba->set($key, sqlite_escape_string($value));
		}
	}
	// restore prefix-settings
	if (isset($_POST['keep_prefix_set'])) {
		foreach ($prefixSettings as $key => $value) {
			$ba->set($key, sqlite_escape_string($value));
		}
	}

	// if E1/T1 module is plugged, we activate the module depending the choice made before to make the factory-reset
	if (isset($_POST['keep_hw_set'])) 
	{
	        if (!($_POST['id_upd']))
	        {
	                // we come directly from RebootReset.php page (modal has not been be shown)
	                // setting default value
	                $default_array = array( 'id_upd' => array ('0', '1'), 'type' => array('cashw', 'cas'), 
	                                        'interface_type1' => '0', 'interface_type2' => '0', 'interface_type3' => '0', 'interface_type4' => '0',
	                                        't1e11' => 'e1', 't1e12' => 'e1', 't1e13' => 'e1', 't1e14' => 'e1');
	
	                $_POST = array_merge($_POST, $default_array);
	        }
	
		$pstn_hw = new PstnHardware();
		$pstn_hw -> change_hardware_configuration($ba, $_POST);	
	
	        $ba -> set('activate', '3');
	}
}

// doesn't this belong into 'create_files.php'??
// reset api-password
@unlink('/usr/conf/apiusers.conf');
require_once('/usr/local/php/include/apiusers.Class.php');
$apiusers=new apiusers('admin');
$apiusers->createFile();

// reset password for user admin and deactivate account
exec('/usr/local/sbin/pwchange.sh admin admin');
exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');

echo '<script>window.location.href="' . (($_POST['v'] == 'Wizard') ? '../../index.php?m=Wizard' : '../../includes/create_files.php') . '"</script>';

?>
